#include "game.h"
#include "mainwindow.h"

//#include <QVBoxLayout>
//#include <QPushButton>
Game::Game(int delay, QWidget *parent): QWidget(parent)
{
    resize(DOT_WIDTH * FIELD_WIDTH, DOT_HEIGHT * FIELD_HEIGHT);// розміри поля

    DELAY=delay;//щоб не було повідомлення, що гра завершилась на самому старті,
    //спочатку встановлюємо таймер потім запускаємо

    initGame();

    //Gamestart(); // початок гри
}


void Game::timerEvent(QTimerEvent * e)
{
    Q_UNUSED(e);
    if (m_inGame) {// якщо ми знаходимся в грі
        chek_apple();// перевірка, чи з'їли яблуко
        move();
        chek_field(); // перевірка межі поля
    }
    this->repaint(); // перемальовка самого себе
}

void Game::keyPressEvent(QKeyEvent *event) //натискання клавіатури
{
    int key = event->key();
    if (key == Qt::Key_Left  && m_dir != Directions::right) { m_dir = Directions::left;  } // вліво - неможливо в вправо
    if (key == Qt::Key_Right && m_dir != Directions::left)  { m_dir = Directions::right; } // вправо - неможливо в ліво
    if (key == Qt::Key_Up    && m_dir != Directions::down)  { m_dir = Directions::up;    } // верх - неможливо в низ
    if (key == Qt::Key_Down  && m_dir != Directions::up)    { m_dir = Directions::down;  } // вниз - неможливо в верх
    if (key == Qt::Key_Escape)   {qApp->quit(); } // закритя вікна
    if (key == Qt::Key_Space) {m_pause();} // пауза
 //       QMessageBox msgb;
  //      msgb.setWindowTitle("Змійка"); // назва вікна
  //      msgb.setWindowIcon(QIcon(":/resources/Image/Icon.png")); // картинка вікна
  //      msgb.setText("Ви в режимі пауза. Натисніть 'ОК' для продовження"); // вивід тексту що гра закінчилась
  //      msgb.exec();
  //      initGame();
    //}
}

void Game::paintEvent(QPaintEvent *event)
{
    Q_UNUSED(event); doDrawing();// функція для відрисовки
}

void Game::doDrawing()// відображення те що маємо
{
    QPainter qp(this); //виконання відрисовки
    if (m_inGame){ // якщо ми в грі, то виконується відрисовка
    setStyleSheet("background-color:black;"); // чорний фон вікна
    qp.setBrush(Qt::red);// заливка фігури червоним
    qp.drawEllipse(m_apple.x() * DOT_WIDTH, m_apple.y() * DOT_HEIGHT, DOT_WIDTH, DOT_HEIGHT); // відрисовка яблука(еліпс) 20 на 20
    for (int i = 0; i <  m_dots.size(); ++i) { // відрисовка змійки

        if (i == 0) {// якщо голова
            qp.setBrush(Qt::white);// заливка фігури білим
            qp.drawEllipse(m_dots[i].x() * DOT_WIDTH, m_dots[i].y() * DOT_HEIGHT, DOT_WIDTH, DOT_HEIGHT); // відрисовка голови
        } else {
            qp.setBrush(Qt::green);// заливка фігури
            qp.drawEllipse(m_dots[i].x() * DOT_WIDTH, m_dots[i].y() * DOT_HEIGHT, DOT_WIDTH, DOT_HEIGHT); // заливка змійки
        }
    }
    } else { //якщо не в грі
        gameOver();
    }
}

void Game::localApple() // розположення яблука
{
    QTime time = QTime::currentTime();// ініцілізація рандома яблука - визивання часу
    srand((uint) time.msec());// рандом час в мілісекундах
    m_apple.rx() = rand() % DOT_WIDTH; //рандом по х
    m_apple.ry() = rand() % DOT_HEIGHT;// рандом по у
}

void Game::move() { // рух змійки

    for (int i = m_dots.size()-1; i > 0; --i) {// двигає хвост на місце предостанього елемента, тобто всі елементи на елемент вперед
    m_dots[i] = m_dots[i-1];
    }
    switch (m_dir) {
        case left:  { m_dots[0].rx() -=1; break; } // рух вліво, х зменшується
        case right: { m_dots[0].rx() +=1; break; } // рух право, х збільшується
        case up:    { m_dots[0].ry() -=1; break; } // рух верх, y зменшується
        case down:  { m_dots[0].ry() +=1; break; } // рух вниз, у зменшується

    }
}

void Game::chek_field() {
    if (m_dots.size() > 4) {// якщо більше 4 елементів змійки, вона може себе вкусити
    for (int i = 1; i < m_dots.size(); ++i) {// перевірка
        if (m_dots[0] == m_dots[i]) { // якщо голова дорівнює якомусь елементу
            m_inGame = false; // завершення гри
        }} }
    if (m_dots[0].x() >= FIELD_WIDTH)  { m_inGame = false; } // перевірка на вихід за межі поля
    if (m_dots[0].x() < 0)             { m_inGame = false; }
    if (m_dots[0].y() >= FIELD_HEIGHT) { m_inGame = false; }
    if (m_dots[0].y() < 0)             { m_inGame = false; }

    if (!m_inGame) {       // Якщо ми не в грі, зупинка таймеру
    killTimer(m_timerId);
    t_active=false;
    }
}
void Game::gameOver() { // виводимо вікно що гра закінчилася
     QMessageBox msgb;
     msgb.setWindowTitle("Змійка"); // назва вікна
     msgb.setWindowIcon(QIcon(":/resources/Image/Icon.png")); // картинка вікна
     msgb.setText("Гра завершилась. Натисніть 'ОК' для продовження"); // вивід тексту що гра закінчилась
     msgb.exec(); // виконання
     initGame(); // коли закінчилось вікно, ми повертаємся в initGame
}

void Game::chek_apple() {
    if (m_apple == m_dots[0]) {  //  якщо яблуко = голові
         m_dots.push_back(QPoint (0,0)); // добавляється тіло
        localApple(); // рандом яблука
    }
}

//void Game::Gamestart()
//{
//    QMessageBox msgb;
//    msgb.setWindowTitle("Змійка"); // назва вікна
//    msgb.setWindowIcon(QIcon(":/resources/Image/Icon.png")); // картинка вікна
//    msgb.setText("Ви в грі. Натисніть 'ОК' щоб розпочати."); // вивід тексту що гра закінчилась
//    msgb.exec(); // виконання
//    initGame(); // коли закінчилось вікно, ми повертаємся в initGame
//}

void Game::m_pause() //пауза
{
    if (t_active)
        {
             killTimer(m_timerId);
        }
   // m_timer.stop();
    QMessageBox msgb;
      msgb.setWindowTitle("Змійка"); // назва вікна
      msgb.setWindowIcon(QIcon(":/resources/Image/Icon.png")); // картинка вікна
      msgb.setText("Ви в режимі пауза. Натисніть 'ОК' для продовження"); // вивід тексту що гра закінчилась
      msgb.exec();
      startTimer(DELAY);
       t_active=true;
     }

//void Game::Pause()
//{
//    if (m_timerId->isActive())
 //      {
 //          m_timerId.stop();
 //      }
//}
void Game::initGame()
{


    m_inGame = true; // якщо в грі
    m_dir = right; // початковий рух змійки вправо
    m_dots.resize(3); // початковий розмір змійки = 3
    for (int i = 0; i < m_dots.size(); ++i) // початкове розміщення змійки
    {
        m_dots[i].rx() = m_dots.size() - i - 1; // розположення змійки
        m_dots[i].ry() = 0;
    }
    localApple(); // розположення яблука

  m_timerId = startTimer(DELAY); // запуск таймера
 t_active=true;
}
